 /*
 * 手太欠
 * 愿这世界都如故事里一样 美好而动人~
 */

Page({
    data: {
        couponType  : 1,      // 兑换券类型
        couponStatus: 1,      // 兑换券状态
        couponArr   : [],     // 兑换券列表
        page        : {},     // 分页信息
        lodingStats : false,  // 加载状态
    },

    onShow() {
        // 获取我的兑换券
        this.couponInfo();
    },

    /**
     * 我的兑换券
     */
    couponInfo(page) {
        wx.$api.mall.mycoupon({
            stock : this.data.couponType,
            status: this.data.couponStatus,
            page  : page || 1
        }).then(res => {
            let listArr = this.data.couponArr,
                newData = []
            if(page == 1 || page == undefined) listArr = []
            newData = listArr.concat(res.data.data)
            this.setData({
                couponArr   : newData,
                page        : res.data.page,
                lodingStats : false
            })
            wx.stopPullDownRefresh()
        }).catch(err => {
            this.setData({
                disabled: true
            })
        })
        
    },

    /**
     * 兑换券-类型
     */
    tabClick(e) {
        this.setData({
            couponType: e.currentTarget.dataset.type
        })
        // 获取我的兑换券
        this.couponInfo();
    },

    /**
     * 兑换券-状态
     */
    stateClick(e) {
        this.setData({
            couponStatus: e.currentTarget.dataset.status
        })
        // 获取我的兑换券
        this.couponInfo();
    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {
        // 获取我的兑换券
        this.couponInfo();
    },

    /**
     * 上拉加载
     */
    onReachBottom(){
        this.setData({
            lodingStats: true
        })
        let pageNumber = this.data.page.current
        if(this.data.page.has_more){
            pageNumber++

            // 获取我的兑换券
            this.couponInfo(pageNumber);
        }
    }
})
